clear
T = 279.45;
R = 8.314; % unit J/mol/K
F = 96485; % C/mol
%% Define volumes (unit pL)
W_i = 4.24e6;
W_e = 6.06e5;
A_cap = 0.3; % Unit cm^2
%Keener, J.P., Sneyd, J.: ‘Mathematical physiology: I: cellular physiology'
%E_Na=56mV, E_K=-77mV
E_Na=50e-3; % unit V
E_K=-77e-3; % unit V
cNao_st = 484; % unit mM
cNai_st=cNao_st/exp(E_Na*F/(R*T));
%cNai_st = 60.7; % unit mM
cKo_st = 20;
cKi_st=cKo_st/exp(E_K*F/(R*T));
%cKi_st = 489.5;
gK_max=36.0; % mS_per_cmsq
gNa_max=120.0;% mS_per_cmsq
zNa=1;
zK=1;
%dNa=483e8; % Na channel density /cm^2
%dK=145e8; % K channel density /cm^2
dNa=1000e8; % Na channel density /cm^2
dK=dNa/gNa_max*gK_max; % K channel density /cm^2
nNa=dNa*A_cap;%the number of Na channel
nK=dK*A_cap; %the number of K channel

G_Na = gNa_max*A_cap; % mS
G_K = gK_max*A_cap; % mS

formatSpec={'%.1f','%d','%g','%.2f','%g','%g','%.3e','%.3e'};
M(1,:)={'Ion','$[X_i]$','$[X_o]$','Channels','Channels($fmol$)','$\bar G^X(mS)$','$P(pL/s)$','$k^+$','$k^-$'};
[P,kf_GHK,kr_GHK,X]=GHK_cal(T,zNa,cNai_st,cNao_st,nNa,W_i,W_e,G_Na);
save(['Na_GHK_paras.mat'],'P','kf_GHK','kr_GHK');
M(2,:)=['Na' compose(formatSpec,[cNai_st,cNao_st,nNa,X,G_Na,P,kf_GHK,kr_GHK])];
[P,kf_GHK,kr_GHK,X]=GHK_cal(T,zK,cKi_st,cKo_st,nK,W_i,W_e,G_K);
save(['K_GHK_paras.mat'],'P','kf_GHK','kr_GHK');
M(3,:)=['K' compose(formatSpec,[cKi_st,cKo_st,nK,X,G_K,P,kf_GHK,kr_GHK])];
writecell(M,'kineticGHK.csv','Delimiter',',')

